package com.plexia.test;

import java.io.IOException;
import java.util.List;

import javax.servlet.*;
import javax.servlet.sip.*;
import javax.servlet.http.*;

public class MnpApp extends SipServlet {

   protected void doInvite(SipServletRequest req) throws ServletException, IOException {

                //Retrieve SipFactory through the context
                ServletContext sc = getServletContext();
                SipFactory sf = (SipFactory) sc.getAttribute("javax.servlet.sip.SipFactory");

                // set the request uri
                SipURI requestUri = sf.createSipURI("393405300695","192.168.1.11");
                req.setRequestURI(requestUri);

                //Clone incoming request
                SipServletRequest downstreamReq = sf.createRequest(req,false);

                //Retrieve SipApplicationSession and SipSessions
                SipApplicationSession sas = req.getSession().getApplicationSession();

                // create new call-id from the old one with 1111 prefix
                String newcid = downstreamReq.getCallId();
                downstreamReq.removeHeader("Call-ID");
                downstreamReq.addHeader("Call-ID","1111" + newcid);

                SipSession upstreamLeg = req.getSession();
                SipSession downstreamLeg = downstreamReq.getSession();

                //Save reference to SipSessions in the SipApplication
                sas.setAttribute("upstreamLeg",upstreamLeg);
                sas.setAttribute("downstreamLeg",downstreamLeg);

                //Save references to the initial request in the SipSession objects
                upstreamLeg.setAttribute("initialRequest",req);
                downstreamLeg.setAttribute("initialRequest", downstreamReq);

                //Send the new req downstream
                downstreamReq.send();
   }

   protected void doResponse(SipServletResponse resp) throws ServletException, IOException {

                //Retrieve the upstream request to respond it
                SipSession upstreamLeg = (SipSession)resp.getSession().getApplicationSession().getAttribute("upstreamLeg");
                SipServletRequest upstreamRequest = (SipServletRequest)upstreamLeg.getAttribute("initialRequest");
                SipServletResponse upstreamResponse = upstreamRequest.createResponse(resp.getStatus(),resp.getReasonPhrase());

                //Copy the content from the downstream response to the upstream response
                if (resp.getContentType() != null) {
                        upstreamResponse.setContent(resp.getRawContent(), resp.getContentType());
                }
                //Send the response upstream
                upstreamResponse.send();
   }

}

